# coding: utf-8
require 'oauth2'

module UzuUzu
  module Controller
    module Login
      #
      #
      #
      class Facebook
        
        #
        #
        #
        def index
          get_config
          session[:referer] = session[:referer] || request.referrer || '/'

          response.redirect @facebook_client.auth_code.authorize_url(
            @auth_param
          )
        rescue => e
          logger.debug "facebook_request_error #{e}"
          response.server_error
        end # index
        
        #
        #
        #
        def callback
          get_config
          
          access_token = @facebook_client.auth_code.get_token(
            request.params[:code],
            @auth_param
          )
          session[:facebook_access_token] = access_token.token
          logger.debug access_token
          
          #session[:login_user_id] = access_token.params[:user_id]
          #session[:login_name] = access_token.params[:screen_name]
          #session[:login_domain] = 'facebook'
          referrer = session[:referer] || '/'
          #session.delete(:referer)
          response.redirect referrer || '/'
        rescue => e
          logger.debug "facebook_callback_error #{e}"
          response.server_error
        end # callback
        
        private
        #
        #
        #
        def get_config
          @config = Environments.current.config['facebook']
          response.server_error if @config.blank?
          if session[:login_user_id]
            referrer = session[:referer] || request.referrer || '/'
            session.delete(:referer)
            response.redirect referrer
          end
          @facebook_client = OAuth2::Client.new(
            @config['client_id'],
            @config['client_secret'],
            :site => 'https://graph.facebook.com'
          )
          @auth_param = {
#            :redirect_uri => "#{helper.root_uri}#{helper.r(:callback)}"
             :redirect_uri => "http://www.uzuuzu.jp"
          }
          @auth_param[:scope] = @config['scope'] if @config['scope']
        end # get_config
        
      end # Facebook
    end # Login
  end # Controller
end # UzuUzu