# coding: utf-8
require 'oauth2'

module UzuUzu
  module Controller
    module Login
      #
      #
      #
      class Google
        
        #
        #
        #
        def index
          get_config
          session[:referer] = session[:referer] || request.referrer || '/'

          response.redirect @google_client.auth_code.authorize_url(
            @auth_param
          )
        rescue => e
          logger.debug "google_request_error #{e}"
          response.server_error
        end # index
        
        #
        #
        #
        def callback
          get_config
          
          access_token = @google_client.auth_code.get_token(
            request.params[:code],
            @auth_param
          )
          session[:google_access_token] = access_token.token
          logger.debug access_token
          
          #session[:login_user_id] = access_token.params[:user_id]
          #session[:login_name] = access_token.params[:screen_name]
          #session[:login_domain] = 'google'
          referrer = session[:referer] || '/'
          #session.delete(:referer)
          response.redirect referrer || '/'
        rescue => e
          logger.debug "google_callback_error #{e}"
          response.server_error
        end # callback
        
        private
        #
        #
        #
        def get_config
          @config = Environments.current.config['google']
          response.server_error if @config.blank?
          if session[:login_user_id]
            referrer = session[:referer] || request.referrer || '/'
            session.delete(:referer)
            response.redirect referrer
          end
          @google_client = OAuth2::Client.new(
            @config['client_id'],
            @config['client_secret'],
            :site => 'https://accounts.google.com',
            :authorize_url => '/o/oauth2/auth',
            :token_url => '/o/oauth2/token'
          )
          @auth_param = {
            :redirect_uri => "#{helper.root_uri}#{helper.r(:callback)}"
#             :redirect_uri => "http://www.uzuuzu.jp"
          }
          @auth_param[:scope] = @config['scope'] if @config['scope']
          @auth_param[:response_type] = @config['response_type'] if @config['response_type']
        end # get_config
        
      end # Google
    end # Login
  end # Controller
end # UzuUzu