# coding: utf-8
require 'oauth'

module UzuUzu
  module Controller
    module Login
      #
      #
      #
      class Twitter
        
        #
        #
        #
        def index
          get_config
          session[:referer] = session[:referer] || request.referrer || '/'
          
          request_token = @twitter_consumer.get_request_token(
            :oauth_callback => "#{helper.root_uri}#{helper.r(:callback)}"
          )
          session[:twitter_request_token] = request_token.token
          session[:twitter_request_token_secret] = request_token.secret
          
          response.redirect request_token.authorize_url
        rescue => e
          logger.debug "twitter_request_error #{e}"
          response.server_error
        end # index
        
        #
        #
        #
        def callback
          get_config
          request_token = ::OAuth::RequestToken.new(
            @twitter_consumer,
            session[:twitter_request_token],
            session[:twitter_request_token_secret]
          )
          access_token = request_token.get_access_token(
            {},
            :oauth_token => request.params[:oauth_token],
            :oauth_verifier => request.params[:oauth_verifier]
          )
          session[:twitter_access_token] = access_token.token
          session[:twitter_access_token_secret] = access_token.secret
          session.delete(:twitter_request_token)
          session.delete(:twitter_request_token_secret)
          
          session[:login_user_id] = access_token.params[:user_id]
          session[:login_name] = access_token.params[:screen_name]
          session[:login_domain] = 'twitter'
          
          referrer = session[:referer] || '/'
          session.delete(:referer)
          response.redirect referrer
        rescue => e
          logger.debug "twitter_callback_error #{e}"
          response.server_error
        end # callback
        
        private
        #
        #
        #
        def get_config
          @config = Environments.current.config['twitter']
          response.server_error if @config.blank?
          if session[:login_user_id]
            referrer = session[:referer] || request.referrer || '/'
            session.delete(:referer)
            response.redirect referrer
          end
          @twitter_consumer = ::OAuth::Consumer.new(
            @config['consumer_key'],
            @config['consumer_secret'],
            :site => 'http://twitter.com'
          )
        end # get_config
        
      end # Twitter
    end # Login
  end # Controller
end # UzuUzu