# coding: utf-8
require 'appengine-apis'
require 'appengine-apis/logger'

module UzuUzu
  module Logger
    class Appengine
      #
      attr_reader :adapter
      #
      #
      #
      def initialize(env=nil)
        @adapter = :appengine
        @logger = AppEngine::Logger.new
        level = env['level'] || :debug
        case(level.to_sym)
        when :info
          @logger.level = ::Logger::Severity::INFO
        when :warn
          @logger.level = ::Logger::Severity::WARN
        when :error
          @logger.level = ::Logger::Severity::ERROR
        when :fatal
          @logger.level = ::Logger::Severity::FATAL
        when :unknown
          @logger.level = ::Logger::Severity::UNKNOWN
        else
          @logger.level = ::Logger::Severity::DEBUG
        end
      end # initialize
      #
      #
      #
      def method_missing(action, *args)
        begin
          args.each do |message|
            message = message.to_str if message.respond_to?(:to_str)
            message = message.inspect unless message.instance_of?(String)
            @logger.send(action, message)
          end
        rescue => e
          # puts standerd error output
          $stderr.puts 'logger unknown error'
          $stderr.puts e
        end
      end # method_missing
      
    end # Appengine
  end # Logger
end # UzuUzu