# coding: utf-8
require 'logger'

module UzuUzu
  module Logger
    class File
      #
      attr_reader :adapter
      #
      #
      #
      def initialize(env=nil)
        @adapter = :file
        out = env['path']
        rotate = (env['rotate'] || 0).to_i
        rotate_size = (env['rotate_size'] || 0).to_i * 1024
        ::FileUtils.mkdir_p(::File.dirname(out))
        @logger = ::Logger.new(out, rotate, rotate_size)
        level = env['level'] || :debug
        case(level.to_sym)
        when :info
          @logger.level = ::Logger::Severity::INFO
        when :warn
          @logger.level = ::Logger::Severity::WARN
        when :error
          @logger.level = ::Logger::Severity::ERROR
        when :fatal
          @logger.level = ::Logger::Severity::FATAL
        when :unknown
          @logger.level = ::Logger::Severity::UNKNOWN
        else
          @logger.level = ::Logger::Severity::DEBUG
        end
      end # initialize
      #
      #
      #
      def method_missing(action, *args)
        begin
          @logger.send(action, *args)
        rescue => e
          # puts standerd error output
          $stderr.puts 'logger unknown error'
          $stderr.puts e
        end
      end # method_missing
      
    end # File
  end # Logger
end # UzuUzu