# coding: utf-8

module UzuUzu
  module Logger
    class Loggers
      #
      attr_reader :adapter
      #
      #
      #
      def initialize(env=nil)
        @adapter = :loggers
        @loggers = []
        unless env
          return
        end
        env.each do |logger_env|
          adapter = logger_env["adapter"]
          require "uzuuzu-core/logger/#{adapter}"
          adapter_class = eval("::UzuUzu::Logger::#{adapter.camel_case}")
          logger = adapter_class.new(logger_env)
          @loggers << logger
        end
      end # initialize
      #
      #
      #
      def method_missing(action, *args)
        @loggers.each do |logger|
          begin
            args.each do |message|
              message = message.to_str if message.respond_to?(:to_str)
              message = message.inspect unless message.instance_of?(String)
              logger.send(action, message)
            end
          rescue => e
            # puts standerd error output
            $stderr.puts 'logger unknown error'
            $stderr.puts e
          end
        end
      end # method_missing
      
    end # Loggers
  end # Logger
end # UzuUzu