# coding: utf-8
require 'leveldb'

module UzuUzu
  module Memcache
    class Leveldb
      #
      attr_reader :adapter
      
      #
      #
      #
      def initialize(env=nil)
        @adapter = :leveldb
        address = 'cache'
        space = 'leveldb'
        if env
          address = env['address'] || address
          space = env['space'] || UzuUzu.application.name || space
        end
        unless ::File.exists?(address)
          ::FileUtils.mkdir_p(address)
        end
        
        @db = LevelDB::DB.new("#{address}/#{space}")
      end
      
      def get(key)
        @db.get(key.to_s)
      end
      alias :[] :get
      
      def put(key, value)
        @db.put(key.to_s, value)
      end
      alias :[]= :put
      
      #
      #
      #
      def method_missing(action, *args)
        @db.send(action, *args)
      end # method_missing
    end # Leveldb
  end # Memcache
end # UzuUzu