# coding: utf-8


module UzuUzu
  class Request < Rack::Request
    
    def self.current
      Thread.current[:request]
    end

    def accept
      @env['HTTP_ACCEPT'].to_s.split(',').map { |a| a.split(';')[0].strip }
    end
    
    def query_suffix
      return @query_suffix if @query_suffix
      if /^.+\.(.+?)$/ =~ self.path
        @query_suffix = $1.to_sym
      else
        @query_suffix = :html
      end
      @query_suffix = :xhr if @query_suffix == :html and self.xhr?
      @query_suffix
    end
    alias :wish :query_suffix
    
    def domain(path = nil, options = {})
      uri = URI(self.url)
      uri.path = path.to_s if path
      uri.query = nil unless options[:keep_query]
      uri.to_s
    end
  end # Request
end # UzuUzu