# coding: utf-8
require 'right_aws'

module UzuUzu
  module Wrapper
    class S3
      #
      attr_reader :s3
      #
      attr_reader :buckets
      
      #
      #
      #
      def initialize(env=nil)
        if env.nil?
        return
        end
        @env = env.dup
        @buckets_env = @env['buckets'].dup
        @access_key = @env['access_key'] || @env[:access_key] ||''
        @secret_key = @env['secret_key'] || @env[:secret_key] ||''
        
       params = {}
       params[:server] = @env['server'] unless @env['server'] .blank?
       params[:port] = @env['port'] unless @env['port'] .blank?
       params[:protocol] = @env['protocol'] unless @env['protocol'] .blank?
       params[:logger] = ::UzuUzu.logger
        @s3 = ::RightAws::S3.new(@access_key, @secret_key, params)
        @buckets = {}
      end # new

      #
      #
      #
      def method_missing(name, *args)
        name = name.to_s
        if @buckets_env[name].nil?
          return nil
        end
        if  @buckets[name].nil?
          params = {}
          params[:location] = @buckets_env[name]['location'] unless @buckets_env[name]['location'].blank?
          params = nil if params.blank?
          @buckets[name] = @s3.bucket(@buckets_env[name]['name'], true, params)
        end
        @buckets[name]
      end # method_missing
      
    end # S3
  end # Wrapper
end # UzuUzu